<?php
/**
* @version      2.4.2 28.10.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerUser extends JController{
    
    function display(){
        $this->myaccount();
    }
    
    function login(){
        $jshopConfig = &JSFactory::getConfig();
        $session =& JFactory::getSession();
        
        $user = &JFactory::getUser();
        if ($user->id){
            $view=&$this->getView("user", 'html');
            $view->setLayout("logout");            
            $view->display();
            return 0;
        }
   
        if (JRequest::getVar('return')){
            $return = JRequest::getVar('return');
        }else{
            $return = $session->get('return');
        }
        
        $show_pay_without_reg = $session->get("show_pay_without_reg");
        
        if (getThisURLMainPageShop()){        
            $document =& JFactory::getDocument();
            $document->setTitle(_JSHOP_LOGIN);            
            appendPathWay(_JSHOP_LOGIN);
        }
        
        //for login-registration template
        $country = &JTable::getInstance('country', 'jshop');        
        $option_country[] = JHTML::_('select.option',  '0', _JSHOP_REG_SELECT, 'country_id', 'name' );    
        $select_countries = JHTML::_('select.genericlist', array_merge($option_country, jshopCountry::getAllCountries()),'country','id = "country" class = "inputbox" size = "1"','country_id','name' );
        foreach ($jshopConfig->arr['title'] as $key => $value) {        
            $option_title[] = JHTML::_('select.option', $key, $value, 'title_id', 'title_name' );    
        }
        $select_titles = JHTML::_('select.genericlist', $option_title,'title','class = "inputbox" id = "title"','title_id','title_name' );
        

        $view=&$this->getView("user", 'html');
        $view->setLayout("login");
        $view->assign('href_register', SEFLink('index.php?option=com_jshopping&controller=user&task=register'));
        $view->assign('href_lost_pass', SEFLInk('index.php?option=com_user&view=reset'));
        $view->assign('return', $return);
        $view->assign('validate', $validate = JUtility::getToken());
        $view->assign('Itemid', JRequest::getVar('Itemid'));
        $view->assign('config', $jshopConfig);
        $view->assign('show_pay_without_reg', $show_pay_without_reg);
        
        $view->assign('select_titles', $select_titles);
        $view->assign('select_countries', $select_countries);
        $view->assign('live_path', JURI::base());
        
        $view->display();
    }
    
    function loginsave(){
        $mainframe =& JFactory::getApplication();
        
        // Check for request forgeries
        JRequest::checkToken('request') or jexit( 'Invalid Token' );
       
        if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
            $return = base64_decode($return);
            if (!JURI::isInternal($return)) {
                $return = '';
            }
        }

        $options = array();
        $options['remember'] = JRequest::getBool('remember', false);
        $options['return'] = $return;

        $credentials = array();
        $credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
        $credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);
        
        //preform the login action
        $error = $mainframe->login($credentials, $options);

        if(!JError::isError($error)){
            // Redirect if the return url is not registration or login
            if ( ! $return ) {
                $return = JURI::base();
            }
            $mainframe->redirect( $return );
        }else{
            // Redirect to a login form
            $mainframe->redirect( SEFLink('index.php?option=com_jshopping&controller=user&task=login&return='.base64_encode($return),0,1) );
        }
    }
    
    function check_user_exist_ajax() {
        $mes = array();
        $username = JRequest::getVar("username");
        $email = JRequest::getVar("email");
        $db = &JFactory::getDBO(); 
        $query = "SELECT id FROM `#__users` WHERE username = '" . $db->getEscaped($username) . "'";
        $db->setQuery($query);
        $db->query();
        if ($db->getNumRows()){ 
            $mes[] = sprintf(_JSHOP_USER_EXIST, $username);
        }
        
        $query = "SELECT id FROM `#__users` WHERE email = '" . $db->getEscaped($email) . "'";
        $db->setQuery($query);
        $db->query();
        if ($db->getNumRows()){ 
            $mes[] = sprintf(_JSHOP_USER_EXIST_EMAIL, $email);
        }
        
        if (count($mes)==0){
            print "1";
        }else{
            print implode("\n",$mes);
        }
        die();
    }
    
    function register(){

        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO(); 
        
        if (getThisURLMainPageShop()){        
            $document =& JFactory::getDocument();
            $document->setTitle(_JSHOP_REGISTRATION);            
            appendPathWay(_JSHOP_REGISTRATION);
        }
        
        // If user registration is not allowed, show 403 not authorized.
        $usersConfig = &JComponentHelper::getParams( 'com_users' );
        if ($usersConfig->get('allowUserRegistration') == '0') {
            JError::raiseError( 403, JText::_( 'Access Forbidden' ));
            return;
        }        
        
        $country = &JTable::getInstance('country', 'jshop');        
        $option_country[] = JHTML::_('select.option',  '0', _JSHOP_REG_SELECT, 'country_id', 'name' );    
        $select_countries = JHTML::_('select.genericlist', array_merge($option_country, jshopCountry::getAllCountries()),'country','id = "country" class = "inputbox" size = "1"','country_id','name' );
        foreach ($jshopConfig->arr['title'] as $key => $value) {        
            $option_title[] = JHTML::_('select.option', $key, $value, 'title_id', 'title_name' );    
        }
        $select_titles = JHTML::_('select.genericlist', $option_title,'title','class = "inputbox" id = "title"','title_id','title_name' );
        
        $view=&$this->getView("user", 'html');
        $view->setLayout("register");
           
        $view->assign('select_titles', $select_titles);
        $view->assign('select_countries', $select_countries);
        $view->assign('live_path', JURI::base());        
        $view->assign('validate', JUtility::getToken());
        $view->display();
    }
    
    function registersave(){
        $mainframe =& JFactory::getApplication();
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        
        $usergroup = &JTable::getInstance('usergroup', 'jshop');
        $default_usergroup = jshopUsergroup::getDefaultUsergroup();
        // Get the constants from com_user
        $lang = & JFactory::getLanguage();
        $lang->load( 'com_user' );
        // End Get constants from com_user

        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $row = &JTable::getInstance('userShop', 'jshop');

        $user         = clone(JFactory::getUser());
        $pathway      =& $mainframe->getPathway();
        $config       =& JFactory::getConfig();
        $authorize    =& JFactory::getACL();
        $document     =& JFactory::getDocument();
        // If user registration is not allowed, show 403 not authorized.
        $usersConfig = &JComponentHelper::getParams( 'com_users' );
        if ($usersConfig->get('allowUserRegistration') == '0') {
            JError::raiseError( 403, JText::_( 'Access Forbidden' ));
            return;
        }

        // Initialize new usertype setting
        $newUsertype = $usersConfig->get( 'new_usertype' );
        if (!$newUsertype) {
            $newUsertype = 'Registered';
        }

        $_POST['username'] = JRequest::getVar('u_name');
        $_POST['password2'] = JRequest::getVar('password_2');
        $_POST['name'] = JRequest::getVar('f_name');
           
        // Bind the post array to the user object
        if(!$row->bind( JRequest::get('post'), 'usertype')) {
            JError::raiseError( 500, $row->getError());
        }
        $row->usergroup_id = $default_usergroup;
        JFilterOutput::objectHTMLSafe($row);

        if (!$user->bind( JRequest::get('post'), 'usertype' )) {
            JError::raiseError( 500, $user->getError());
        }

        // Set some initial user values
        $user->set('id', 0);
        $user->set('usertype', '');
        $user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));
        $date =& JFactory::getDate();
        $user->set('registerDate', $date->toMySQL());
        // If user activation is turned on, we need to set the activation information
        $useractivation = $usersConfig->get( 'useractivation' );
        if ($useractivation == '1')
        {
            jimport('joomla.user.helper');
            $user->set('activation', md5( JUserHelper::genRandomPassword()) );
            $user->set('block', '1');
        }
        
        if(!$row->check()) {
            JError::raiseWarning('', $row->getError());
            $this->setRedirect(SEFLink("index.php?option=com_jshopping&controller=user&task=register",0,1));
            return 0;
        }

        // If there was an error with registration, set the message and display form
        if ( !$user->save() ){
            JError::raiseWarning('', JText::_( $user->getError()));
            $this->setRedirect("index.php?option=com_jshopping&controller=user&task=register");
            return false;
        }
        
        $row->user_id = $user->id;
        if (!$db->insertObject($row->getTableName(), $row, $row->getKeyName())){
            JError::raiseWarning('', "Error insert in table ".$row->getTableName());
            $this->setRedirect(SEFLink("index.php?option=com_jshopping&controller=user&task=register",0,1));
            return 0;
        }        

        // Send registration confirmation mail
        $password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
        $password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
        require_once(JPATH_SITE . DS . "components" . DS . "com_user" . DS . "controller.php");
        UserController::_sendMail($user, $password);
        // TODO hier bug
        
        // Everything went fine, set relevant message depending upon user activation state and display message
        if ( $useractivation == 1 ){
            $message  = JText::_('_REG_COMPLETE_ACTIVATE');
            $return = SEFLink("index.php?option=com_jshopping&controller=user&task=login",0,1);
        } else {
            $message = JText::_('REG_COMPLETE');
            $return = SEFLink("index.php?option=com_jshopping&controller=user&task=login",0,1);
        }
        
        $this->setRedirect($return, $message);
    }
    
    function editaccount(){
    
        checkUserLogin();
        $user = &JFactory::getUser();
        $adv_user = &JSFactory::getUserShop();
        $jshopConfig = &JSFactory::getConfig();
                
        $document =& JFactory::getDocument();
        $document->setTitle(_JSHOP_EDIT_DATA);            
        appendPathWay(_JSHOP_EDIT_DATA);    
        
        $country = &JTable::getInstance('country', 'jshop');
        $option_country[] = JHTML::_('select.option', 0, _JSHOP_REG_SELECT, 'country_id', 'name' );
        $option_countryes = array_merge($option_country,jshopCountry::getAllCountries());    
        $select_countries = JHTML::_('select.genericlist', $option_countryes,'country','id = "country" class = "inputbox" size = "1"','country_id', 'name',$adv_user->country );
        $select_d_countries = JHTML::_('select.genericlist', $option_countryes,'d_country','id = "d_country" class = "inputbox" size = "1"','country_id', 'name',$adv_user->d_country );

        foreach ($jshopConfig->arr['title'] as $key => $value) {        
            $option_title[] = JHTML::_('select.option', $key, $value, 'title_id', 'title_name' );    
        }    
        $select_titles = JHTML::_('select.genericlist', $option_title,'title','class = "inputbox" id = "title"','title_id','title_name',$adv_user->title );
        $select_d_titles = JHTML::_('select.genericlist', $option_title,'d_title','class = "inputbox" id = "d_title"','title_id','title_name',$adv_user->d_title );
        
        filterHTMLSafe( $adv_user, ENT_QUOTES);        
        
        $view=&$this->getView("user", 'html');
        $view->setLayout("editaccount");
        
        $view->assign('select_countries',$select_countries);
        $view->assign('select_d_countries',$select_d_countries);
        $view->assign('select_titles',$select_titles);
        $view->assign('select_d_titles',$select_d_titles);
        $view->assign('live_path', JURI::base());
        $view->assign('user', $adv_user);
        $view->assign('delivery_adress', $adv_user->delivery_adress);
        $view->assign('action', SEFLink('index.php?option=com_jshopping&controller=user&task=accountsave'));
        $view->display();    
    }
    
    function accountsave(){
        checkUserLogin();
        $user = &JFactory::getUser();
        $db = &JFactory::getDBO();
        
        $user_shop = &JTable::getInstance('userShop', 'jshop');        
        $post = JRequest::get('post');
        unset($post['user_id']);
        unset($post['usergroup_id']);
        $user_shop->load($user->id);
        $user_shop->bind($post);
        
        if(!$user_shop->check(1)) {
            JError::raiseWarning('',$user_shop->getError());
            $this->setRedirect(SEFLink("index.php?option=com_jshopping&controller=user&task=editaccount",0,1));
            return 0;
        }
        
        if(!$user_shop->store()) {
            JError::raiseWarning('',_JSHOP_REGWARN_ERROR_DATABASE);
            $this->setRedirect(SEFLink("index.php?option=com_jshopping&controller=user&task=editaccount",0,1));
            return 0;
        }
        
        $user = clone(JFactory::getUser());
        $user->email = $user_shop->email;
        $user->save();        
                
        $this->setRedirect(SEFLink("index.php?option=com_jshopping&controller=user&task=myaccount",0,1), _JSHOP_ACCOUNT_UPDATE);
    }
    
    function orders(){
        $jshopConfig = &JSFactory::getConfig();
        checkUserLogin();
        $user = &JFactory::getUser();
        $order = &JTable::getInstance('order', 'jshop');
        
        $document =& JFactory::getDocument();
        $document->setTitle(_JSHOP_MY_ORDERS);            
        appendPathWay(_JSHOP_MY_ORDERS);
        
        $orders = jshopOrder::getOrdersForUser($user->id);
        foreach ($orders as $key => $value) {
            $orders[$key]->order_href = SEFLink('index.php?option=com_jshopping&controller=user&task=order&order_id=' . $value->order_id);
        }
        
        $view=&$this->getView("order", 'html');        
        $view->setLayout("listorder");
        $view->assign('orders', $orders);
        $view->assign('image_path', $jshopConfig->live_path."images");
        $view->display();
    }
    
    function order(){
        $jshopConfig = &JSFactory::getConfig();
        checkUserLogin();
        $db = &JFactory::getDBO(); 
        $user = &JFactory::getUser();
        $lang = &JSFactory::getLang();
        
        $document =& JFactory::getDocument();
        $document->setTitle(_JSHOP_MY_ORDERS);            
        appendPathWay(_JSHOP_MY_ORDERS);
        
        $order_id = JRequest::getInt('order_id');
        
        $order = &JTable::getInstance('order', 'jshop');        
        $order->load($order_id);
        
        if ($user->id!=$order->user_id){
            JError::raiseError( 500, "Error order number");    
        }
        
        $order->items = $order->getAllItems();
        $order->status_name = $order->getStatus();
        $order->history = $order->getHistory();
        
        $shipping_method =&JTable::getInstance('shippingMethod', 'jshop');
        $shipping_method->load($order->shipping_method_id);
        
        $name = $lang->get("name");
        $order->shipping_info = $shipping_method->$name;
        
        $country = &JTable::getInstance('country', 'jshop');
        $country->load($order->country);
        $field_country_name = $lang->get("name");
        $order->country = $country->$field_country_name;
        
        $d_country = &JTable::getInstance('country', 'jshop');
        $d_country->load($order->d_country);
        $field_country_name = $lang->get("name");
        $order->d_country = $d_country->$field_country_name;
        
        $order->order_tax_list = $order->getTaxExt();
        $show_percent_tax = 0;        
        if (count($order->order_tax_list)>1 || $jshopConfig->show_tax_in_product) $show_percent_tax = 1;
        if ($jshopConfig->hide_tax) $show_percent_tax = 0;
        $hide_subtotal = 0;
        if ($jshopConfig->hide_tax && $order->order_discount==0 && $jshopConfig->without_shipping) $hide_subtotal = 1;
        
        $text_total = _JSHOP_ENDTOTAL;
        if ($jshopConfig->show_tax_in_product || $jshopConfig->show_tax_product_in_cart){
            $text_total = _JSHOP_ENDTOTAL_INKL_TAX;
        }

        $view=&$this->getView("order", 'html');
        $view->setLayout("order");
        $view->assign('order', $order);
        $view->assign('config', $jshopConfig);
        $view->assign('text_total', $text_total);
        $view->assign('show_percent_tax', $show_percent_tax);
        $view->assign('hide_subtotal', $hide_subtotal);
        $view->assign('image_path', $jshopConfig->live_path . "images");
        $view->display();
        
    }
    
    function myaccount(){
        checkUserLogin();

        $view=&$this->getView("user", 'html');
        $view->setLayout("myaccount");
        $view->assign('href_edit_data', SEFLink('index.php?option=com_jshopping&controller=user&task=editaccount'));
        $view->assign('href_show_orders', SEFLink('index.php?option=com_jshopping&controller=user&task=orders'));

        $view->display();
    }
    
    function logout(){
        $mainframe =& JFactory::getApplication();

        //preform the logout action
        $error = $mainframe->logout();
        
        $session =& JFactory::getSession();
        $session->set('user_shop_guest', null);
        $session->set('cart', null);

        if(!JError::isError($error)){
            if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
                $return = base64_decode($return);
                if (!JURI::isInternal($return)) {
                    $return = '';
                }
            }

            // Redirect if the return url is not registration or login
            if ( $return && !( strpos( $return, 'com_user' )) ) {
                $mainframe->redirect( $return );
            }else{
                $mainframe->redirect(JURI::base());
            }
        }
    }
    
}
?>